package kr.co.vividnext.sodalive.audition

import kr.co.vividnext.sodalive.audition.role.AuditionRoleDetailViewModel

class AuditionRepository(
    private val api: AuditionApi
) {
    fun getAuditionList(
        page: Int,
        size: Int,
        token: String
    ) = api.getAuditionList(
        page = page - 1,
        size = size,
        authHeader = token
    )

    fun getAuditionDetail(
        auditionId: Long,
        token: String
    ) = api.getAuditionDetail(
        id = auditionId,
        authHeader = token
    )

    fun getAuditionRoleDetail(
        auditionRoleId: Long,
        token: String
    ) = api.getAuditionRoleDetail(
        id = auditionRoleId,
        authHeader = token
    )

    fun getAuditionApplicantList(
        auditionRoleId: Long,
        sortType: AuditionRoleDetailViewModel.AuditionApplicantSortType,
        page: Int,
        size: Int,
        token: String
    ) = api.getAuditionApplicantList(
        auditionRoleId = auditionRoleId,
        sortType = sortType,
        page = page - 1,
        size = size,
        authHeader = token
    )
}
